Bug 1305737 - Review Request: reprepro - Tool to handle local repositories of Debian packages
Summary: Review Request: reprepro - Tool to handle local repositories of Debian packages
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jens Lody
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1170529 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-02-09 04:14 UTC by Ken Dreyer
Modified: 2016-03-09 14:27 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-02-29 22:20:22 UTC
fedora: fedora-review+


Attachments (Terms of Use)

Description Ken Dreyer 2016-02-09 04:14:12 UTC
Spec URL: https://fedorapeople.org/cgit/ktdreyer/public_git/reprepro.git/plain/reprepro.spec
SRPM URL: https://ktdreyer.fedorapeople.org/reviews/reprepro-4.17.0-1.fc24.src.rpm
Description: reprepro is a tool to manage a repository of Debian packages (.deb). It stores files either being injected manually or downloaded from some other repository (partially) mirrored into one pool/ hierarchy.  Managed packages and files are stored in a Berkeley DB, so no database server is needed. Checking signatures of mirrored repositories and creating signatures of the generated Package indexes is supported.
Fedora Account System Username: ktdreyer

Rawhide (F24) scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=12912136

Comment 1 Ken Dreyer 2016-02-09 21:53:55 UTC
*** Bug 1170529 has been marked as a duplicate of this bug. ***

Comment 2 Ken Dreyer 2016-02-13 22:03:25 UTC
Unfortunately fedorapeople.org's cgit is not operational. Here are alternative links:

Spec URL: https://ktdreyer.fedorapeople.org/reviews/reprepro.spec
SRPM URL: https://ktdreyer.fedorapeople.org/reviews/reprepro-4.17.0-1.fc24.src.rpm

Comment 3 Jens Lody 2016-02-16 05:13:42 UTC
I take this.

Still some minor issues:

COPYING has to use %license-macro instead of %doc.

The docs-folder should not be included completely, because it doubles the man-pages, includes the Makefile{.in,.am} and the bash- and zsh-completion-files.

The latter should be packaged also (if possible), at least for the users convenience, but of course at the correct places.

You should also add a comment, why you do not use the tests.

And you should add a comment, why the main url is from Debian, but the package source from Ubuntu.

The package does not install with fedora-review in rawhide (error 30), but if I remember correctly,this is not a packge but a fedora-review/mock-issue.
It seems to work fine in el7.

By the way, do you also plan to package pbuilder ?
I use it to build Debian-packages of Code::Blocks on my CentOS 7 Server.
I would use Reprepro to build the repo (if it is packkaged),currently I use a self-written script, which works quite good for my purposes.
I also use pbuilder (quick hacked package there).

Comment 4 Ken Dreyer 2016-02-17 05:17:21 UTC
Thanks for taking this review! Here's a new build with your suggested changes.

* Wed Feb 17 2016 Ken Dreyer <ktdreyer@ktdreyer.com> - 4.17.0-2
- Mark COPYING as %%license (rhbz#1305737)
- Install bash and zsh completion files to usable locations (rhbz#1305737)
- Remove unneeded files from /docs/ (rhbz#1305737)
- Comment regarding the use of Source0 upstream URL (rhbz#1305737)
- Comment regarding test suite (rhbz#1305737)

Spec URL: https://ktdreyer.fedorapeople.org/reviews/reprepro.spec
SRPM URL: https://ktdreyer.fedorapeople.org/reviews/reprepro-4.17.0-2.fc24.src.rpm

Comment 5 Ken Dreyer 2016-02-17 05:19:02 UTC
(my exact changes in git: https://github.com/ktdreyer/reprepro-rpm/commit/f901ca1dd2427470c42492af00f66a3538ee5286)

Comment 6 Upstream Release Monitoring 2016-02-17 05:23:13 UTC
ktdreyer's scratch build of reprepro-4.17.0-2.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=13017331

Comment 7 Jens Lody 2016-02-18 06:48:17 UTC
Looks fine so far, despite of a minor issue I have overlooked:
some of the scripts in the docs-folder still have the executable-bit set, leading to doc-file-dependencies.
They should (must) be avoided, see: https://fedoraproject.org/wiki/Packaging:Guidelines#Documentation

Just a simple chmod -x on all files in docs is enough.
e.g.:

# Remove executable bits from files in doc-dir to avoid doc-file-dependencies as
# required by the packaging guidelines
find docs -type f -exec chmod -x {} +


This can also be done when importing the package.

Formal review comes later this day, I have to go to doctor with my daughter now.

Comment 8 Jens Lody 2016-02-18 21:18:39 UTC
Package approved, please add code to remove executable bits from examples in doc-directory, when importing to git.

Jens



Formal package Review (comments between ###-lines)
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "GPL (v2 or later)", "GPL (v2)", "Unknown
     or generated", "*No copyright* Public domain". 101 files have unknown
     license. Detailed output of licensecheck in
     /home/jens/reviews/rawhide/1305737-reprepro/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
###
Not installed for debug-package, but this never happens for autogenerated
debug-packages and they can not be used without the main-package.
###
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/share/bash-
     completion(kmod, dnf, rpmdevtools, python-pip, rpmlint, bash-
     completion, subversion, gvfs-client, tracker, yum, python3-pip, glib2,
     git-core, gpaste), /usr/share/zsh/site-functions(systemd, pulseaudio,
     gpaste), /usr/share/bash-completion/completions(kmod, dnf,
     rpmdevtools, python-pip, rpmlint, firewalld, libappstream-glib,
     subversion, gvfs-client, tracker, yum, bash-completion, python3-pip,
     glib2, git-core, gpaste), /usr/share/zsh(systemd, pulseaudio, gpaste)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 225280 bytes in 19 files.
[x]: Package complies to the Packaging Guidelines
###
Executable bits should/must be removed from all diles in doc-directory,
see comment above.
###
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
###
The package can be installed in rawhide, it does not work with
fedora-review/mock, but this seems to happen in other packages, too.
No such issue with fedora-review for epel7.
###
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     reprepro-debuginfo
###
This is never the case for autogenerated debug-packages.
###
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
###
See comment in spec-files, test-dependencies are not fulfilled on Fedora.
###
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
###
This seems to be a fedora-review/mock issue, see above.
###
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.2.14 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.14
INFO: Mock Version: 1.2.14
Finish: chroot init
INFO: installing package(s): /home/jens/reviews/rawhide/1305737-reprepro/results/reprepro-4.17.0-2.fc24.x86_64.rpm /home/jens/reviews/rawhide/1305737-reprepro/results/reprepro-debuginfo-4.17.0-2.fc24.x86_64.rpm /home/jens/reviews/rawhide/1305737-reprepro/results/reprepro-debuginfo-4.17.0-2.fc24.x86_64.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 24 --setopt=deltarpm=false install /home/jens/reviews/rawhide/1305737-reprepro/results/reprepro-4.17.0-2.fc24.x86_64.rpm /home/jens/reviews/rawhide/1305737-reprepro/results/reprepro-debuginfo-4.17.0-2.fc24.x86_64.rpm /home/jens/reviews/rawhide/1305737-reprepro/results/reprepro-debuginfo-4.17.0-2.fc24.x86_64.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: reprepro-4.17.0-2.fc24.x86_64.rpm
          reprepro-debuginfo-4.17.0-2.fc24.x86_64.rpm
          reprepro-4.17.0-2.fc24.src.rpm
reprepro.x86_64: W: doc-file-dependency /usr/share/doc/reprepro/docs/pdiff.example /usr/bin/env
reprepro.x86_64: W: doc-file-dependency /usr/share/doc/reprepro/docs/outsftphook.py /usr/bin/python
reprepro.x86_64: W: doc-file-dependency /usr/share/doc/reprepro/docs/outstore.py /usr/bin/python
3 packages and 0 specfiles checked; 0 errors, 3 warnings.
###
The warnings go away, if the executable-buits are removed from exxamples in doc-directory.
###



Requires
--------
reprepro (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/env
    /usr/bin/python
###
These three come from the doc-file-dependencies.
###
    libarchive.so.13()(64bit)
    libbz2.so.1()(64bit)
    libc.so.6()(64bit)
    libdb-5.3.so()(64bit)
    libgpg-error.so.0()(64bit)
    libgpg-error.so.0(GPG_ERROR_1.0)(64bit)
    libgpgme.so.11()(64bit)
    libgpgme.so.11(GPGME_1.0)(64bit)
    libgpgme.so.11(GPGME_1.1)(64bit)
    liblzma.so.5()(64bit)
    liblzma.so.5(XZ_5.0)(64bit)
    libz.so.1()(64bit)
    libz.so.1(ZLIB_1.2.0.2)(64bit)
    rtld(GNU_HASH)

reprepro-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
reprepro:
    reprepro
    reprepro(x86-64)

reprepro-debuginfo:
    reprepro-debuginfo
    reprepro-debuginfo(x86-64)



Source checksums
----------------
https://launchpad.net/ubuntu/+archive/primary/+files/reprepro_4.17.0.orig.tar.gz :
  CHECKSUM(SHA256) this package     : 97ef4dc26f6f81981a591d620adadb233074a36d7e042d56711eb4e885ce68fa
  CHECKSUM(SHA256) upstream package : 97ef4dc26f6f81981a591d620adadb233074a36d7e042d56711eb4e885ce68fa


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1305737 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 9 Ken Dreyer 2016-02-20 03:06:32 UTC
Thanks for the review! My latest version has your suggested change for the docs.

* Sat Feb 20 2016 Ken Dreyer <ktdreyer@ktdreyer.com> - 4.17.0-3
- Remove execute bit from docs files (rhbz#1305737)

Spec URL: https://ktdreyer.fedorapeople.org/reviews/reprepro.spec
SRPM URL: https://ktdreyer.fedorapeople.org/reviews/reprepro-4.17.0-3.fc24.src.rpm

Exact change in Git: https://github.com/ktdreyer/reprepro-rpm/commit/f71977450b39d889f466f0c5ccc56d6cb9f66233

I've requested the new package in pkgdb.

Comment 10 Gwyn Ciesla 2016-02-20 20:37:39 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/reprepro

Comment 11 Fedora Update System 2016-02-21 05:39:11 UTC
reprepro-4.17.0-3.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-5c8a7e84f6

Comment 12 Fedora Update System 2016-02-21 05:39:35 UTC
reprepro-4.17.0-3.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2016-0766785061

Comment 13 Fedora Update System 2016-02-21 05:40:01 UTC
reprepro-4.17.0-3.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-3edb28335c

Comment 14 Fedora Update System 2016-02-22 04:20:22 UTC
reprepro-4.17.0-3.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-0766785061

Comment 15 Fedora Update System 2016-02-22 04:21:48 UTC
reprepro-4.17.0-3.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-5c8a7e84f6

Comment 16 Fedora Update System 2016-02-22 04:51:11 UTC
reprepro-4.17.0-3.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-3edb28335c

Comment 17 Fedora Update System 2016-02-29 22:20:18 UTC
reprepro-4.17.0-3.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2016-02-29 22:22:14 UTC
reprepro-4.17.0-3.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2016-03-09 14:27:33 UTC
reprepro-4.17.0-3.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.